#include <cstdio>
using namespace std;

const int MAX_N  = 1<<12;
const int INF    = 1<<20;
const double eps = 1e-9;

struct point { double x, y; };

///// input file
double A;
int n;
point P[MAX_N];

///// output file
point ans;     // cupola

void read_input (char *f)
{
	FILE *fin = fopen(f,"r");

	int i;
	double B, C;

	fscanf (fin, "%lf%lf%lf", &A, &B, &C);
	fscanf (fin, "%d", &n);

	for (i=0; i<n; i++)
		fscanf (fin, "%lf%lf", &P[i].x, &P[i].y);

	fclose (fin);
}

void read_output (char *f)
{
	FILE *fin = fopen(f,"r");

	fscanf (fin, "%lf%lf", &ans.x, &ans.y);

	fclose (fin);
}

void check (char *f)
{
	FILE *fout = fopen(f,"w");

	int i;
	double Ycupola;
	double B = -2.0*A*ans.x;
	double C = ans.y - (A*ans.x+B)*ans.x;
	bool wrong=0;

//	printf ("ans: %lf %lf\n", ans.x, ans.y);
//	printf ("%lf %lf %lf\n", A, B, C);

	for (i=0; i<n; i++) {
		Ycupola = (A*P[i].x+B)*P[i].x + C;
		if (Ycupola < P[i].y-eps) {
			if (!wrong) {
				wrong=1;
				fprintf (fout, "%d\n", INF);
			}
			fprintf (fout, "Point #%d with coordinates (%.0lf;%.0lf) not below the cupola(here Y<=%.4lf)\n", i+1, P[i].x, P[i].y, Ycupola);
		}
	}

	if (!wrong) fprintf (fout, "%lf\n", ans.y);

	fclose (fout);
}

int main (int argn, char* args[])
{
	if (argn!=4) {
		printf ("args: <IF> <OF> <RES>\n");
		return 1;
	}
	
	read_input (args[1]);
	read_output (args[2]);
	check (args[3]);

	return 0;
}