#include <iostream>
#include <cmath>
#include <time.h>
using namespace std;
#define eps 1e-3
int N;
struct P
{
double x,y;
P(){}
P(double _x, double _y)
 {
 x = _x;
 y = _y;
 }
};
P points[2501];
double A,B,C;

void init()
 {
  scanf("%lf %lf %lf",&A,&B,&C);
  scanf("%d",&N);
  int i;
  for(i = 1; i <= N; i++)
   {
    double a1,b1;
     scanf("%lf %lf",&a1,&b1);
     points[i] = P(a1,b1);
   }
 }

double gety(double a,double b,double c, double x)
  {
    return a*x*x + b*x + c;
  }


double binary(double a,double b,double x)
 {
  double l,r; 
  double c;
  l = 0.0;
  r = 100000.0;
  double mid;
  int i;
  double ans = -1; 
   while(fabs(l - r) > eps && l <= r)
   {
    mid = (l+r)/2;
    c = mid - a*x*x - b*x;
    bool status = 1;
     for(i = 1; i <= N; i++)
      {
       if(gety(a,b,c,points[i].x) < points[i].y) {status = 0; break;}
      }
    if(status == 1)
     {
      ans = mid;
      r = mid - eps;
     }
     else
     {
      l = mid + eps;
     }
   }
  return ans;
 }


double solve()
 {
  double l,r;
  l = 0;
  r = 50.0;
  double ans = -1;
  double mid,mid1,mid2;
  while( fabs(l - r) > eps && l <= r)
   {
    ans = mid;
    mid = (l+r)/2;
    mid1 = mid + eps;
    mid2 = mid - eps;
    double y,y1,y2;
// printf("%.9lf %.9lf %.9lf\n",l,r,mid);
      
// printf("%.9lf %.9lf %.9lf\n",mid,mid1,mid2);
    y = binary(A,-2*A*mid,mid);
    y1 = binary(A,-2*A*mid1,mid1);
    y2 = binary(A,-2*A*mid2,mid2);
   // printf("%.9lf %.9lf %.9lf\n",y,y1,y2);
      
  if( fabs(y - y1) > 0 && y <= y1 && fabs( y - y2 ) > 0 && y <= y2) { //printf("%.1lf\n",mid); 
return mid; }
    else if(y > y1) l = mid1; 
         else r = mid2;
   }
   return ans;
 }

double slow()
 {
 
 double x = 0.0;
 double savex = -1;
 double mini = 999999999.0;
 double last = -1; 
 for(x = 0.0; x <= 50.0; x+=0.01)
   {
    
    B = -2*A*x;
    if(mini > binary(A,B,x))
    {
     mini = binary(A,B,x);
     savex = x;
    }
     //mini = min(mini,binary(A,B,x));
   //  printf("%.10lf\n",binary(A,B,x));
   }
//printf("%.1lf\n",savex);
   return savex;
 }

clock_t begin;

int main()
{
init();
double x = solve();
printf("%.2lf %.2lf\n",x,binary(A,-2*A*x,x));
printf("%.4lf\n",double(clock())/CLOCKS_PER_SEC);
begin = clock();
x = slow();
printf("%.2lf %.2lf\n",x,binary(A,-2*A*x,x));
printf("%.4lf\n",double(clock()-begin)/CLOCKS_PER_SEC);
printf("%.2lf %.2lf\n",3.0,binary(A,-2*A*3,3));
return 0;
}
